; 
	include masm32rt.inc
	test_enum_display_array	proto :DWORD,:DWORD,:DWORD
; 
	.data
	tmp		dd	0
	pstr	dd	0
	str1	db	"6AaAaAaAa",0
	str2	db	"5BbBbBbBb",0
	str3	db	"4CcCcCcCc",0
	str4	db	"3DdDdDdDd",0
	str5	db	"2EeEeEeEe",0
	str6	db	"1FfFfFfFf",0
	err1	db	"OK",13,10,0
	err2	db	"ERROR: no memory",13,10,0
	err3	db	"ERROR: out of range",13,10,0
	err4	db	"NULL PTR: string empty",13,10,0
	err5	db	"NOT FOUND",13,10,0
	err6	db	"FAIL",13,10,0
	line0	db	"----------------------------------------------------",13,10,0

	.code
; 
start:
; 

	mov		pstr,rv(sa_Create,5)							; only 5 strings, simple test
	print	str$(pstr),9," Create: 5 - result: "
	.if		pstr == 0
		print	addr err2
	.else
		print	addr err1
	.endif

	print	addr line0

	mov		tmp, rv(sa_Add, pstr, addr str1)
	print	str$(tmp),9," Add: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr str1,13,10
	.endif

	mov		tmp, rv(sa_Add, pstr, addr str2)
	print	str$(tmp),9," Add: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr str2,13,10
	.endif

	mov		tmp, rv(sa_Add, pstr, addr str3)
	print	str$(tmp),9," Add: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr str3,13,10
	.endif

	mov		tmp, rv(sa_Add, pstr, addr str4)
	print	str$(tmp),9," Add: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr str4,13,10
	.endif

	mov		tmp, rv(sa_Add, pstr, addr str5)
	print	str$(tmp),9," Add: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr str5,13,10
	.endif

	mov		tmp, rv(sa_Add, pstr, addr str6)
	print	str$(tmp),9," Add: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr str6,13,10
	.endif

	print	addr line0

	mov		tmp, rv(sa_Del, pstr, 0)
	print	str$(tmp),9," Del: 0 - result: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr err4
	.endif

	mov		tmp, rv(sa_Del, pstr, 6)
	print	str$(tmp),9," Del: 6 - result: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr err4
	.endif

	mov		tmp, rv(sa_Del, pstr, 5)
	print	str$(tmp),9," Del: 5 - result: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr err4
	.endif

	mov		tmp, rv(sa_Del, pstr, 1)
	print	str$(tmp),9," Del: 1 - result: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr err4
	.endif

	print	addr line0

	mov		tmp, rv(sa_Replace, pstr, 0, addr str6)
	print	str$(tmp),9, " Replace: 0 1FfFfFfFf - result: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_Replace, pstr, 6, addr str6)
	print	str$(tmp),9, " Replace: 6 1FfFfFfFf - result: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_Replace, pstr, 2, addr str6)
	print	str$(tmp),9, " Replace: 2 1FfFfFfFf - result: "
	.if		tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	print	addr line0

	mov		tmp, rv(sa_Get, pstr, 0)
	mov		ebx, ecx										; store size
	print	str$(tmp),9," Get: 0 - result: "
	.if	tmp == -1
		print	addr err3
	.elseif tmp == 0
		print	addr err4
	.else
		print	"addr of string ",34
		print	dword ptr tmp,34," - size: "
		print	str$(ebx),13,10
	.endif

	mov		tmp, rv(sa_Get, pstr, 6)
	mov		ebx, ecx										; store size
	print	str$(tmp),9," Get: 6 - result: "
	.if	tmp == -1
		print	addr err3
	.elseif tmp == 0
		print	addr err4
	.else
		print	"addr of string ",34
		print	dword ptr tmp,34," - size: "
		print	str$(ebx),13,10
	.endif

	mov		tmp, rv(sa_Get, pstr, 5)
	mov		ebx, ecx										; store size
	print	str$(tmp),9," Get: 5 - result: "
	.if	tmp == -1
		print	addr err3
	.elseif tmp == 0
		print	addr err4
	.else
		print	"addr of string ",34
		print	dword ptr tmp,34," - size: "
		print	str$(ebx),13,10
	.endif

	mov		tmp, rv(sa_Get, pstr, 3)
	mov		ebx, ecx										; store size
	print	str$(tmp),9," Get: 3 - result: "
	.if	tmp == -1
		print	addr err3
	.elseif tmp == 0
		print	addr err4
	.else
		print	"addr of string ",34
		print	dword ptr tmp,34," - size: "
		print	str$(ebx),13,10
	.endif

	print	addr line0

	mov		tmp, rv(sa_SetIndex, pstr, 0)
	print	str$(tmp),9," SetIndex: 0 - result: "
	.if tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_SetIndex, pstr, 6)
	print	str$(tmp),9," SetIndex: 6 - result: "
	.if tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_SetIndex, pstr, 1)
	print	str$(tmp),9," SetIndex: 1 - result: "
	.if tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	print	str$(rv(sa_GetIndex, pstr)),9," GetIndex:",13,10
	print	str$(rv(sa_GetCount, pstr)),9," GetCount:",13,10
	print	str$(rv(sa_GetSize, pstr)),9," GetSize:",13,10

	print	addr line0

	mov		tmp, rv(sa_FindEmptyIndex, pstr, 0)
	print	str$(tmp),9," FindEmptyIndex: 0 - result: "
	.if tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_FindEmptyIndex, pstr, 6)
	print	str$(tmp),9," FindEmptyIndex: 6 - result: "
	.if tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_FindEmptyIndex, pstr, 1)
	print	str$(tmp),9," FindEmptyIndex: 1 - result: "
	.if tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_FindEmptyIndex, pstr, 3)
	print	str$(tmp),9," FindEmptyIndex: 3 - result: "
	.if tmp == -1
		print	addr err3
	.else
		print	addr err1
	.endif

	print	addr line0

	mov		tmp, rv(sa_Find, pstr, "3dDdDdDdD", 0)
	print	str$(tmp),9," Find: 3dDdDdDdD (nocase) - result: "
	.if tmp == -1
		print	addr err5
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_Find, pstr, "3dDdDdDdD", 1)
	print	str$(tmp),9," Find: 3dDdDdDdD (case)   - result: "
	.if tmp == -1
		print	addr err5
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_Find, pstr, "0ZzZzZzZz", 0)
	print	str$(tmp),9," Find: 0ZzZzZzZz (nocase) - result: "
	.if tmp == -1
		print	addr err5
	.else
		print	addr err1
	.endif

	mov		tmp, rv(sa_Find, pstr, "0ZzZzZzZz", 1)
	print	str$(tmp),9," Find: 0ZzZzZzZz (case)   - result: "
	.if tmp == -1
		print	addr err5
	.else
		print	addr err1
	.endif

	print	addr line0

	mov		tmp, rv(sa_Expand, pstr, 5)
	print	str$(tmp),9," Expand: 5 - result: "
	.if tmp == -1
		print	addr err3
	.elseif	tmp == 0
		print	addr err2
	.else
		push	tmp
		pop		pstr
		print	addr err1
	.endif

	mov		tmp, rv(sa_Expand, pstr, 9)
	print	str$(tmp),9," Expand: 9 - result: "
	.if tmp == -1
		print	addr err3
	.elseif	tmp == 0
		print	addr err2
	.else
		push	tmp
		pop		pstr
		print	addr err1
	.endif

	print	str$(rv(sa_GetSize, pstr)),9," GetSize:",13,10

	mov		tmp, rv(sa_Get, pstr, 3)
	mov		ebx, ecx										; store size
	print	str$(tmp),9," Get: 3 - result: "
	.if	tmp == -1
		print	addr err3
	.elseif tmp == 0
		print	addr err4
	.else
		print	"addr of string ",34
		print	dword ptr tmp,34," - size: "
		print	str$(ebx),13,10
	.endif

	print	addr line0

	invoke	sa_SetIndex, pstr, 5
	print	"Array unsort",13,10
	invoke	sa_Enum, pstr, addr test_enum_display_array, 0
	print	"---- Reverse order",13,10
	invoke	sa_Enum, pstr, addr test_enum_display_array, 1
	invoke	sa_Sort, pstr, 1, 0
	print	"Array sort",13,10
	invoke	sa_Enum, pstr, addr test_enum_display_array, 0

	print	addr line0

	mov		tmp, rv(sa_Destroy, pstr)
	print	str$(tmp),9," Destroy: - result: "
	.if		tmp == 0
		print	addr err1
	.else
		print	addr err6
	.endif

	print	addr line0

	mov		eax, input(13,10,"Press enter to exit...")
	exit
; 

test_enum_display_array proc pArray:DWORD,iString:DWORD,pString:DWORD

	push	esi
	mov		esi, pString
	print	" Index: "
	print	str$(iString)
	print	" - String: "
	print	dword ptr esi
	print	" - Size: "
	print	str$([esi-4]),13,10
	mov		eax, 1
	pop		esi
	ret

test_enum_display_array endp

end start