; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

	szCompare	PROTO	:DWORD,:DWORD
	szComparei	PROTO	:DWORD,:DWORD

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_Find proc pArray:DWORD,pString:DWORD,fCase:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ebx
	push	esi
	push	edi

	mov		ebx, [esp+4*4]									; pArray
	mov		esi, [esp+5*4]									; pString
	mov		edi, [ebx+_size]								; size

	.while edi > 0
		mov		eax, [ebx+edi*4+_reserved]
		test	eax, eax
		jz		@continue

		add		eax, 4										; skip size
		cmp		dword ptr [esp+6*4], 0						; fCase
		jz		@F

		invoke	szCompare, eax, esi
		test	eax, eax
		jnz		@continue

		mov		eax, edi
		jmp		@exit
@@:
		invoke	szComparei, eax, esi
		test	eax, eax
		jnz		@continue

		mov		eax, edi
		jmp		@exit
@continue:
		sub		edi, 1
	.endw

	mov		eax, -1
@exit:
	pop		edi
	pop		esi
	pop		ebx
	ret		3*4

sa_Find endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
