; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_FindEmptyIndex proc pArray:DWORD,InitialIndex:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ebx

	mov		ebx, [esp+2*4]									; pArray
	mov		ecx, [esp+3*4]									; InitialIndex
	mov		edx, [ebx+_size]								; size

	.if		ecx <= 0										; valid InitialIndex?
		mov		eax, -1
		jmp		@exit
	.endif

	.while ecx <= edx
		mov		eax, [ebx+ecx*4+_reserved]
		test	eax, eax
		jnz		@F

		mov		eax, ecx
		jmp		@exit
@@:
		add		ecx, 1
	.endw		

	mov		eax, -1
@exit:
	pop		ebx
	ret		2*4

sa_FindEmptyIndex endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
