; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_Enum proc pArray:DWORD,pCallBack:DWORD,bReverse:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ebx
	push	edi
	push	esi
	push	ebp

	mov		ebx, [esp+5*4]									; pArray
	mov		esi, [esp+6*4]									; pCallBack
	mov		ebp, [ebx+_size]								; size
	xor		edi, edi
	add		edi, 1

	invoke	IsBadCodePtr, esi
	test	eax, eax
	jz		@F

	mov		eax, -1
	jmp		@exit
@@:
	cmp		dword ptr [esp+7*4], 0
	jnz		@reverse

	.while edi <= ebp
		mov		eax, [ebx+edi*4+_reserved]
		test	eax, eax									; ptr null?
		jz		@F

		add		eax, 4										; skip size
		push	eax											; string
		push	edi											; index
		push	ebx											; pArray
		call	esi											; pCallBack
		test	eax, eax
		jz		@exit
@@:
		add		edi, 1
	.endw
	jmp		@exit
@reverse:
	.while ebp > 0
		mov		eax, [ebx+ebp*4+_reserved]
		test	eax, eax									; ptr null?
		jz		@F

		add		eax, 4										; skip size
		push	eax											; string
		push	ebp											; index
		push	ebx											; pArray
		call	esi											; pCallBack
		test	eax, eax
		jz		@exit
@@:
		sub		ebp, 1
	.endw
@exit:
	pop		ebp
	pop		esi
	pop		edi
	pop		ebx
	ret		3*4

sa_Enum endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
